=== debian/changelog ===
undertaker (1.3b-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Apply patch from Fedora by Jerry James, to fix FTBFS against new
    picosat. (Closes: #699575)

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Fri, 25 Oct 2013 15:37:31 +0100

undertaker (1.3b-1) unstable; urgency=low

  [ Christoph Egger ]
  * drop patches

  [ Reinhard Tartler ]
  * Tighten build dependency on libpuma

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 30 Jun 2012 12:10:46 +0200
