=== debian/rules ===
#!/usr/bin/make -f

UPSTREAM_VERSION=$(shell cat VERSION)

%:
	dh --with python2 $@ --parallel

version.h:
	echo 'const char * version = "$(UPSTREAM_VERSION)";' > $@

override_dh_auto_build: version.h
	dh_auto_build

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

override_dh_auto_test:
	#$(MAKE) check
