=== python/Makefile ===
--- 
+++ 
@@ -1,5 +1,7 @@
-PYTHONFILES=golem rsf2model undertaker-calc-coverage $(wildcard vamos/*/*.py) $(wildcard vamos/*.py)
-SEARCHPATH="$(CURDIR)/../undertaker:$(CURDIR)/../ziz:$(CURDIR):$(PATH)"
+PYTHONPROGRAMS = busyfix golem rsf2model undertaker-calc-coverage undertaker-kconfigpp \
+	vampyr undertaker-checkpatch
+PYTHONFILES    = $(PYTHONPROGRAMS) $(wildcard vamos/*/*.py) $(wildcard vamos/*.py)
+SEARCHPATH     = "$(CURDIR)/../undertaker:$(CURDIR)/../ziz:$(CURDIR):$(PATH)"
 
 all:
 
@@ -26,6 +28,9 @@
                      -o -name "*.error.expected" \
                      -o -name "*.error.diff" \
                      -o -name "*.error.got" \
+                     -o -name "*.c.config*" \
+                     -o -name "*.c.cppflags*" \
+                     -o -name "*.c.source*" \
                      -o -name "*.dead" \
                      -o -name "*.undead" \
                      -o -name "*.plist" \
