=== debian/changelog ===
undertaker (1.6-2) unstable; urgency=medium

  * Use system picsoat >= 960 (Closes: #766273)
  * Apply logic bugfix from upstream for undertaker-checkpatch when
    calucating statistics about Kconfig changes.

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 11 Nov 2014 23:05:38 -0500

undertaker (1.6-1) unstable; urgency=medium

  * New upstream release
  * Drop undertaker-el package. Sorry, I don't have enough time and expertise
    to maintain this integration. Co-Maintainers welcome. Emacs users please
    setup this package in your personal .emacs startup files.
    (Closes: #724535, 724536)

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 19 Oct 2014 12:26:18 -0400

undertaker (1.5-1) unstable; urgency=low

  * New upstream release
  * update emacs dependency (Closes: #754029)
  * Bump standards version (no changes needed)

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 29 Sep 2014 22:19:38 -0400

undertaker (1.4-1) experimental; urgency=low

  * New upstream release
  * Improve package description. Thanks to Justin B Rye <jbr@edlug.org.uk>
    for the great suggestions! Closes: #696159
  * Bump debhelper compat level to 9

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 18 Dec 2012 13:35:31 +0100
