=== debian/rules ===
#!/usr/bin/make -f

UPSTREAM_VERSION=$(shell cat VERSION)

%:
	dh $@ --with python2 --parallel

version.h:
	echo 'const char * version = "$(UPSTREAM_VERSION)";' > $@

override_dh_auto_build: version.h
	dh_auto_build

override_dh_auto_install:
	dh_auto_install -- DESTDIR="$(CURDIR)/debian/tmp" PREFIX=/usr ETCDIR=/etc SETUP_PY_INSTALL_EXTRA_ARG="--root $(CURDIR)/debian/tmp --install-layout=deb"

override_dh_auto_test:
	#$(MAKE) check

override_dh_auto_clean:
	$(MAKE) clean
	rm -rf build
